searchData={"content_type":"text/markdown","items":[{"doc":"Main module to handle requests to the Betterez's APIs.","ref":"BtrzExApiClient.html","title":"BtrzExApiClient","type":"module"},{"doc":"This function will prepare and do the request through the HTTP client and will handle success and errors responses.","ref":"BtrzExApiClient.html#request/6","title":"BtrzExApiClient.request/6","type":"function"},{"doc":"* `:x_api_key` - Optional. This value will be placed in the `x-api-key` header.\n  * `:internal` - Optional. Boolean. If `true` it will use the main/secondary keys (passed via config) for getting an internal JWT to be set in the `Authorization` header. Defaults to `false`.\n  * `:token` - Optional. Set the JWT in the `Authorization` header. If `:internal` option is `true`, this option will be discarded.","ref":"BtrzExApiClient.html#request/6-headers","title":"headers - BtrzExApiClient.request/6","type":"function"},{"doc":"Using the HTTPoison options (https://hexdocs.pm/httpoison/HTTPoison.Request.html)","ref":"BtrzExApiClient.html#request/6-options","title":"options - BtrzExApiClient.request/6","type":"function"},{"doc":"BtrzExApiClient types.","ref":"BtrzExApiClient.Types.html","title":"BtrzExApiClient.Types","type":"module"},{"doc":"The default error tuple.","ref":"BtrzExApiClient.Types.html#t:error/0","title":"BtrzExApiClient.Types.error/0","type":"type"},{"doc":"HTTP headers.\n\nHeaders are sent and received as lists of two-element tuples containing two strings,\nthe header name and header value.","ref":"BtrzExApiClient.Types.html#t:headers/0","title":"BtrzExApiClient.Types.headers/0","type":"type"},{"doc":"The allowed HTTP methods.\n\nMethods are defined as atoms.","ref":"BtrzExApiClient.Types.html#t:methods/0","title":"BtrzExApiClient.Types.methods/0","type":"type"},{"doc":"Available Account endpoints in `btrz-api-accounts`.","ref":"BtrzExApiClient.Accounts.Account.html","title":"BtrzExApiClient.Accounts.Account","type":"module"},{"doc":"","ref":"BtrzExApiClient.Accounts.Account.html#path/0","title":"BtrzExApiClient.Accounts.Account.path/0","type":"function"},{"doc":"Retrive a(n) Account by its ID","ref":"BtrzExApiClient.Accounts.Account.html#retrieve/3","title":"BtrzExApiClient.Accounts.Account.retrieve/3","type":"function"},{"doc":"Available Lexicon endpoints in `btrz-api-accounts`.","ref":"BtrzExApiClient.Accounts.Lexicon.html","title":"BtrzExApiClient.Accounts.Lexicon","type":"module"},{"doc":"","ref":"BtrzExApiClient.Accounts.Lexicon.html#buscompany/2","title":"BtrzExApiClient.Accounts.Lexicon.buscompany/2","type":"function"},{"doc":"","ref":"BtrzExApiClient.Accounts.Lexicon.html#buscompany_path/0","title":"BtrzExApiClient.Accounts.Lexicon.buscompany_path/0","type":"function"},{"doc":"Create a(n) Lexicon","ref":"BtrzExApiClient.Accounts.Lexicon.html#create/3","title":"BtrzExApiClient.Accounts.Lexicon.create/3","type":"function"},{"doc":"","ref":"BtrzExApiClient.Accounts.Lexicon.html#path/0","title":"BtrzExApiClient.Accounts.Lexicon.path/0","type":"function"},{"doc":"Available Permission endpoints in `btrz-api-accounts`.","ref":"BtrzExApiClient.Accounts.Permission.html","title":"BtrzExApiClient.Accounts.Permission","type":"module"},{"doc":"","ref":"BtrzExApiClient.Accounts.Permission.html#import/3","title":"BtrzExApiClient.Accounts.Permission.import/3","type":"function"},{"doc":"","ref":"BtrzExApiClient.Accounts.Permission.html#import_path/0","title":"BtrzExApiClient.Accounts.Permission.import_path/0","type":"function"},{"doc":"List all Permissions","ref":"BtrzExApiClient.Accounts.Permission.html#list/3","title":"BtrzExApiClient.Accounts.Permission.list/3","type":"function"},{"doc":"","ref":"BtrzExApiClient.Accounts.Permission.html#path/0","title":"BtrzExApiClient.Accounts.Permission.path/0","type":"function"},{"doc":"Available Role endpoints in `btrz-api-accounts`.","ref":"BtrzExApiClient.Accounts.Role.html","title":"BtrzExApiClient.Accounts.Role","type":"module"},{"doc":"","ref":"BtrzExApiClient.Accounts.Role.html#import/3","title":"BtrzExApiClient.Accounts.Role.import/3","type":"function"},{"doc":"","ref":"BtrzExApiClient.Accounts.Role.html#import_path/0","title":"BtrzExApiClient.Accounts.Role.import_path/0","type":"function"},{"doc":"List all Roles","ref":"BtrzExApiClient.Accounts.Role.html#list/3","title":"BtrzExApiClient.Accounts.Role.list/3","type":"function"},{"doc":"","ref":"BtrzExApiClient.Accounts.Role.html#path/0","title":"BtrzExApiClient.Accounts.Role.path/0","type":"function"},{"doc":"Available User endpoints in `btrz-api-accounts`.","ref":"BtrzExApiClient.Accounts.User.html","title":"BtrzExApiClient.Accounts.User","type":"module"},{"doc":"","ref":"BtrzExApiClient.Accounts.User.html#import/3","title":"BtrzExApiClient.Accounts.User.import/3","type":"function"},{"doc":"","ref":"BtrzExApiClient.Accounts.User.html#import_path/0","title":"BtrzExApiClient.Accounts.User.import_path/0","type":"function"},{"doc":"List all Users","ref":"BtrzExApiClient.Accounts.User.html#list/3","title":"BtrzExApiClient.Accounts.User.list/3","type":"function"},{"doc":"","ref":"BtrzExApiClient.Accounts.User.html#path/0","title":"BtrzExApiClient.Accounts.User.path/0","type":"function"},{"doc":"Available Station endpoints in `btrz-api-inventory`.","ref":"BtrzExApiClient.Inventory.Station.html","title":"BtrzExApiClient.Inventory.Station","type":"module"},{"doc":"","ref":"BtrzExApiClient.Inventory.Station.html#import/3","title":"BtrzExApiClient.Inventory.Station.import/3","type":"function"},{"doc":"","ref":"BtrzExApiClient.Inventory.Station.html#import_path/0","title":"BtrzExApiClient.Inventory.Station.import_path/0","type":"function"},{"doc":"List all Stations","ref":"BtrzExApiClient.Inventory.Station.html#list/3","title":"BtrzExApiClient.Inventory.Station.list/3","type":"function"},{"doc":"","ref":"BtrzExApiClient.Inventory.Station.html#path/0","title":"BtrzExApiClient.Inventory.Station.path/0","type":"function"},{"doc":"Available Manifest endpoints in `btrz-api-operations`.","ref":"BtrzExApiClient.Operations.Manifest.html","title":"BtrzExApiClient.Operations.Manifest","type":"module"},{"doc":"","ref":"BtrzExApiClient.Operations.Manifest.html#dispatch_reporting/3","title":"BtrzExApiClient.Operations.Manifest.dispatch_reporting/3","type":"function"},{"doc":"","ref":"BtrzExApiClient.Operations.Manifest.html#dispatch_reporting_path/1","title":"BtrzExApiClient.Operations.Manifest.dispatch_reporting_path/1","type":"function"},{"doc":"","ref":"BtrzExApiClient.Operations.Manifest.html#path/0","title":"BtrzExApiClient.Operations.Manifest.path/0","type":"function"},{"doc":"Retrive a(n) Manifest by its ID","ref":"BtrzExApiClient.Operations.Manifest.html#retrieve/3","title":"BtrzExApiClient.Operations.Manifest.retrieve/3","type":"function"},{"doc":"Available Ticket endpoints in `btrz-api-operations`.","ref":"BtrzExApiClient.Operations.Ticket.html","title":"BtrzExApiClient.Operations.Ticket","type":"module"},{"doc":"","ref":"BtrzExApiClient.Operations.Ticket.html#path/0","title":"BtrzExApiClient.Operations.Ticket.path/0","type":"function"},{"doc":"Retrive a(n) Ticket by its ID","ref":"BtrzExApiClient.Operations.Ticket.html#retrieve/3","title":"BtrzExApiClient.Operations.Ticket.retrieve/3","type":"function"},{"doc":"Available Transaction endpoints in `btrz-api-operations`.","ref":"BtrzExApiClient.Operations.Transaction.html","title":"BtrzExApiClient.Operations.Transaction","type":"module"},{"doc":"","ref":"BtrzExApiClient.Operations.Transaction.html#path/0","title":"BtrzExApiClient.Operations.Transaction.path/0","type":"function"},{"doc":"Retrive a(n) Transaction by its ID","ref":"BtrzExApiClient.Operations.Transaction.html#retrieve/3","title":"BtrzExApiClient.Operations.Transaction.retrieve/3","type":"function"},{"doc":"Available Subscription endpoints in `btrz-api-webhooks`.","ref":"BtrzExApiClient.Webhooks.Subscription.html","title":"BtrzExApiClient.Webhooks.Subscription","type":"module"},{"doc":"List all Subscriptions","ref":"BtrzExApiClient.Webhooks.Subscription.html#list/3","title":"BtrzExApiClient.Webhooks.Subscription.list/3","type":"function"},{"doc":"","ref":"BtrzExApiClient.Webhooks.Subscription.html#path/0","title":"BtrzExApiClient.Webhooks.Subscription.path/0","type":"function"},{"doc":"Available Undelivered endpoints in `btrz-api-webhooks`.","ref":"BtrzExApiClient.Webhooks.Undelivered.html","title":"BtrzExApiClient.Webhooks.Undelivered","type":"module"},{"doc":"Create a(n) Undelivered","ref":"BtrzExApiClient.Webhooks.Undelivered.html#create/3","title":"BtrzExApiClient.Webhooks.Undelivered.create/3","type":"function"},{"doc":"","ref":"BtrzExApiClient.Webhooks.Undelivered.html#path/0","title":"BtrzExApiClient.Webhooks.Undelivered.path/0","type":"function"},{"doc":"Failure to connect to Betterez's API.","ref":"BtrzExApiClient.APIConnectionError.html","title":"BtrzExApiClient.APIConnectionError","type":"exception"},{"doc":"API errors cover any other type of problem (e.g., a temporary problem with\nBetterez's servers) and are extremely uncommon.","ref":"BtrzExApiClient.APIError.html","title":"BtrzExApiClient.APIError","type":"exception"},{"doc":"Failure to properly authenticate yourself in the request.","ref":"BtrzExApiClient.AuthenticationError.html","title":"BtrzExApiClient.AuthenticationError","type":"exception"},{"doc":"Invalid request errors arise when your request has invalid parameters.","ref":"BtrzExApiClient.InvalidRequestError.html","title":"BtrzExApiClient.InvalidRequestError","type":"exception"},{"doc":"# BtrzExApiClient\n\nElixir Betterez's APIs client.","ref":"readme.html","title":"BtrzExApiClient","type":"extras"},{"doc":"API documentation at HexDocs [https://hexdocs.pm/btrz_ex_api_client](https://hexdocs.pm/btrz_ex_api_client)","ref":"readme.html#documentation","title":"Documentation - BtrzExApiClient","type":"extras"},{"doc":"```elixir\ndef deps do\n  [{:btrz_ex_api_client, \"~> 0.6.0\"}]\nend\n```","ref":"readme.html#installation","title":"Installation - BtrzExApiClient","type":"extras"},{"doc":"Add the services base endpoints (mandatory)\n\n```elixir\nconfig :btrz_ex_api_client, :services,\n  accounts: \"http://localhost:3050/accounts/\",\n  webhooks: \"http://localhost:4000/webhooks/\"\n  # ... etc\n```\n\nIf you will need the Betterez internal JWT (inter-application auth) you have provide your secret keys in your config file (it's optional depending you will use internal token)\n\n```elixir\nconfig :btrz_ex_api_client, :internal_token,\n  main_secret: \"A_SECRET_KEY\",\n  secondary_secret: \"A_SECRET_KEY\"\n```","ref":"readme.html#configuration","title":"Configuration - BtrzExApiClient","type":"extras"},{"doc":"Depending your resource, it will implement the basic CRUD actions and will be invoked as follows:\n\n  * `BtrzExApiClient.{RESOURCE}.create/2` (POST)\n  * `BtrzExApiClient.{RESOURCE}.retrieve/2` (GET)\n  * `BtrzExApiClient.{RESOURCE}.update/3` (PUT)\n  * `BtrzExApiClient.{RESOURCE}.list/2` (GET)\n  * `BtrzExApiClient.{RESOURCE}.delete/3` (DELETE)\n\nThe endpoints will return `{:ok, response}` or `{:error, ERROR_STRUCT}`, depending the case.","ref":"readme.html#basic-usage","title":"Basic usage - BtrzExApiClient","type":"extras"},{"doc":"* `%APIConnectionError{}` - Failure to connect to Betterez's API.\n  * `%AuthenticationError{}` - Failure to properly authenticate yourself in the request.\n  * `%InvalidRequestError{}` - Invalid request errors arise when your request has invalid parameters.\n  * `%APIError{}` - Other generic errors","ref":"readme.html#posible-errors","title":"Posible errors - BtrzExApiClient","type":"extras"},{"doc":"Please be careful with the folder structure, this example is under `lib/btrz_ex_api_client/accounts/`\nThe `use BtrzExApiClient.API` macro will receive a list of `:atoms` of the pre-defined actions desired.\n\n```elixir\ndefmodule BtrzExApiClient.Accounts.User do\n  use BtrzExApiClient.API, [:list, :create, :retrieve, :delete, :update]\n\n  def path do\n    Application.get_env(:btrz_ex_api_client, :services)[:accounts] <> \"users\"\n  end\nend\n```\n\nYou might want to add custom routes, i.e: a POST accounts/users/import:\n\n```elixir\ndefmodule BtrzExApiClient.Accounts.User do\n  use BtrzExApiClient.API, [:list, :create, :retrieve, :delete, :update]\n\n  def path do\n    Application.get_env(:btrz_ex_api_client, :services)[:accounts] <> \"users\"\n  end\n\n  def import_path() do\n    path() <> \"/import\"\n  end\n\n  def import(data, opts \\\\ []) do\n    BtrzExApiClient.request(:post, import_path(), [], data, opts)\n  end\nend\n```","ref":"readme.html#adding-new-endpoints","title":"Adding new endpoints - BtrzExApiClient","type":"extras"},{"doc":"Betterez API's use the `x-api-key` and `Authorization` headers, depending the endpoint, they can be sent via the `opts` param:\n\n  * `BtrzExApiClient.Accounts.User.list([x_api_key: my_x_api_key])` - will add the `x-api-key` header.\n  * `BtrzExApiClient.Accounts.User.list([x_api_key: my_x_api_key, internal: true])` - will request an internal token to the Betterez provider using the config keys and will add it to the `Authorization` header (using the Bearer JWT).\n  * `BtrzExApiClient.Accounts.User.list([x_api_key: x_api_key, token: my_token])` - will add the user token to the `Authorization` header (using the Bearer JWT).","ref":"readme.html#betterez-auth","title":"Betterez Auth - BtrzExApiClient","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}